/*
 * Lamppost.h
 *
 *  Created on: 02 ago 2016
 *      Author: giuseppe
 */

#ifndef LAMPPOST_H_
#define LAMPPOST_H_


#include "Location.h"
#include "Event.h"
#include <time.h>
#include <string>
#include <fstream>
#include <string>
#include <cstdlib>
#include <sstream>
#include <vector>
#include <cmath>
#include <stdlib.h>
#include <map>
#include <list>
#include <algorithm>
#include <iomanip>



struct Lamppost{

	int id_lamppost;            /**< Lamppost ID */
    string type_lamppost;       /**< Type of Lamppost */
    Location loc;              	/**< Geographical position of the Lamppost */
    int status;
    tm timestamp;
    int user;

	Lamppost(int A, string B, Location C, int D, tm E, int F):id_lamppost(A),type_lamppost(B), loc(C), status(D), timestamp(E), user(F){} /**< Constructor of the struct Lampposts*/
};

typedef std::list<Lamppost> Lampposts;  /**< List of antenna */

bool lamppostsComparator(const Lamppost& lhs, const Lamppost& rhs);
Lampposts mapLampposts(string textFileLamppostsLocation, string lampposts);
int numberOfLampposts(Lampposts lamppostsLFunc);
Lampposts computeLamppostsHistory(Lampposts lamppostsLFunc, float energyConsumptionValue, Events eventsL,string typeLamp);
float readEnergyConsumptionValue(string typeLamps);
double computeEnergyConsumption(Lampposts lamppostsLFunc, float energyConsumptionValue);
double computeEnergyConsumptionAlwaysSwitchOn(Lampposts lamppostsLFunc, float energyConsumptionValue, int startHour, int finishHour, string typeLamp, int numberOfLampposts);
void computePercentageDifference(double referenceValue, double otherValue);
double computeHistoryTck(Lampposts lamppostsLFunc, float energyConsumptionValue, Events eventsL,string typeLamp);
void comparison(Lampposts lamppostsLFunc, float energyConsumptionValue, Events eventsL,string typeLamp);
#endif /* LAMPPOST_H_ */
