/*
 * MapCity.h

 *
 *  Created on: 30 giu 2016
 *  Author: Giuseppe Cacciatore
 */

#ifndef MAPCITY_H_
#define MAPCITY_H_

#include <fstream>
#include <iostream>
#include <string>
#include <cstdlib>
#include <sstream>
#include <vector>
#include <cmath>
#include <stdlib.h>
#include <map>
#include <list>
#include <algorithm>
#include <iomanip>

using namespace std;

/**
 * It computes the distance between two general points in the map
 * Inputs: Longitude and latitude of two points
 * Outputs: double value of the distance
 *
 */
double dist(double th1, double ph1, double th2, double ph2);

/**
 * It creates two different files:
 * - MapGraphPoints.txt: it contains a list of points and every adjacent points, where users can move. The points including within the ray are called adjacent
 * - MapAssociation.txt: it contains the list of all points (with geographical references) where the pedestrians move.
 */
void creatingMapAssociationGraphPoints(string mapPointsCentreCity, string nameCity);

typedef std::map<int, list<int> > GraphCityMap;

#endif /* MAPCITY_H_ */
