/*
 * Smartphones.h

 *
 *  Created on: 30 giu 2016
 *  Author: Giuseppe Cacciatore
 */

#ifndef SMARTPHONES_H_
#define SMARTPHONES_H_

#include "Sample.h"

/**
 * The amount of data to be delivered
 */
typedef std::map<string, float> DatatbdelM;

/**
 * The amount of data already sent
 */
typedef std::map<string, float> DatasentM;

using namespace std;

struct Smartphone{

	int id_user;                /**< User ID */
	float battery;              /**< Battery Level (0-100) */
	string context;             /**< Context (outdoor, semi-outdoor, indoor) */
	DatatbdelM dtbd;            /**< Amount of data to be delivered */
	DatasentM dts;              /**< Amount of data already sent */
	Samples smp;                /**<  List of samples */

	Smartphone(int A, float B, string (C), DatatbdelM (D), DatasentM (E), Samples(F)): id_user(A), battery(B), context(C), dtbd(D), dts(E), smp(F) {}
};

typedef std::map<int,Smartphone> Smartphones;

/**
 *  It sets the details of the smartphone for each user
 */
Smartphones setSmartphones(int num_users);

#endif /* SMARTPHONES_H_ */
